#include "morph.h"

double normorig (Vertex a) { //renvoit la norme d un vecteur partant de l origine

  return sqrt(a.x*a.x+a.y*a.y+a.z*a.z);
}

double norm (Vertex a, Vertex b) { //renvoit la norme d un vecteur 

  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)+(a.z-b.z)*(a.z-b.z));
}

Vertex vect (Vertex a, Vertex b) { // renvoit un vecteur a partir de deux points

  Vertex k;

  k.x= a.x-b.x;
  k.y= a.y-b.y;
  k.z= a.z-b.z;

 return k;

}

Vertex vect_proj_orig (Vertex a) {// renvoit un vecteur a partir d un point. on considere les coordonnes projetes...

  Vertex k;

  k.x= a.xp;
  k.y= a.yp;
  k.z= a.zp;

 return k;


}



Vertex vect_proj (Vertex a, Vertex b) { // renvoit un vecteur a partir de deux points. on considere les coordonnes projetes...

  Vertex k;

  k.x= a.xp-b.xp;
  k.y= a.yp-b.yp;
  k.z= a.zp-b.zp;

 return k;

}


Vertex vect_norm (Vertex a, Vertex b) { // renvoit un vecteur NORME a partir de deux points

  Vertex k;
  double n;

  k= vect (a, b);

  n= normorig(k);
  
  k.x= k.x/n;
  k.y= k.y/n;
  k.z= k.z/n;

  return k;
  
}

Vertex vect_norm_proj (Vertex a, Vertex b) { // renvoit un vecteur NORME a partir de deux points. on considere les coords proj

  Vertex k;
  double n;

  k= vect_proj (a, b);

  n= normorig(k);
  
  k.x= k.x/n;
  k.y= k.y/n;
  k.z= k.z/n;

  return k;
  
}

// scprod ralise le produit scalaire de deux vecteurs

double scprod (Vertex a, Vertex b) {

  return (a.x)*(b.x)+(a.y)*(b.y)+(a.z)*(b.z);

}

double gauss_2 (double a11, double a12, double a21, double a22, double b1, double b2){

  double c,d;

  c= a22-a12*(a21/a11);
  d= b2-b1*(a21/a11);

  return (d/c);

}


Vertex gauss_2_fond (double a11, double a12, double a21, double a22, double b1, double b2) {

  double c,d;
  Vertex k;
  

  c= a22-a12*(a21/a11);
  d= b2-b1*(a21/a11);

  k.y= (d/c);

  k.x= (b1-a12*k.y)/a11;

  return k;

}


// gauss_3 rsoud un systeme de Gauss 3*3 NON DEGENERE (pas de test sur le determinant)
// attention seule la valeur Z est renvoye (ici on n'a besoin que de celle la dans intersect)


double gauss_3 ( double a11, double a21, double a31, double a12,double a22, double a32, double a13,double a23, double a33, double b1,double b2,double b3) {
  
  double c11,c12,c21,c22,d1,d2;
  
  c11= a22-a12*(a21/a11);
  c12= a23-a13*(a21/a11);
  c21= a32-a12*(a31/a11);
  c22= a33-a13*(a31/a11);

  d1=b2-b1*(a21/a11);
  d2=b3-b1*(a31/a11);

  return gauss_2(c11,c12,c21,c22,d1,d2);

}

Vertex gauss_3_fond ( double a11, double a21, double a31, double a12,double a22, double a32, double a13,double a23, double a33, double b1,double b2,double b3) {
  
  double c11,c12,c21,c22,d1,d2;
  Vertex k1,k2;

  c11= a22-a12*(a21/a11);
  c12= a23-a13*(a21/a11);
  c21= a32-a12*(a31/a11);
  c22= a33-a13*(a31/a11);

  d1=b2-b1*(a21/a11);
  d2=b3-b1*(a31/a11);

  k1= gauss_2_fond (c11,c12,c21,c22,d1,d2);

  k2.y=k1.x;
  k2.z=k1.y;

  k2.x= (b1-a12*k2.y-a13*k2.z)/a11;

    return k2;

}


Vertex gauss_3_vect_fond ( Vertex *a1,Vertex *a2, Vertex *a3, Vertex *b) {
  
  double a11, a12, a13, a21, a22, a23, a31, a32, a33, b1, b2, b3;

  a11= a1->x;
  a21= a1->y;
  a31= a1->z;

  a12= a2->x;
  a22= a2->y;
  a32= a2->z;
  
  a13= a3->x;
  a23= a3->y;
  a33= a3->z;

  b1= b->x;
  b2= b->y;
  b3= b->z;

  return gauss_3_fond (a11,a21,a31,a12,a22,a32,a13,a23,a33,b1,b2,b3);

}



double gauss_3_vect ( Vertex *a1,Vertex *a2, Vertex *a3, Vertex *b) {
  
  double a11, a12, a13, a21, a22, a23, a31, a32, a33, b1, b2, b3;

  a11= a1->x;
  a21= a1->y;
  a31= a1->z;

  a12= a2->x;
  a22= a2->y;
  a32= a2->z;
  
  a13= a3->x;
  a23= a3->y;
  a33= a3->z;

  b1= b->x;
  b2= b->y;
  b3= b->z;

  return gauss_3 (a11,a21,a31,a12,a22,a32,a13,a23,a33,b1,b2,b3);

}


//point_is_in_face teste si un point donne (qui est dans le plan defini par la face) est bien contenu a l interieur du triangle

int point_is_in_face (Vertex *a, Face *f, Model *m) {

  double t;

  Vertex v1,v2,v3,v4,w1,w2;

    v1= vect_norm_proj (m->points[f->p2],m->points[f->p1]);
    v2= vect_norm_proj (m->points[f->p3],m->points[f->p2]);
    v3= vect_norm_proj (m->points[f->p3],m->points[f->p1]);
    v4= vect_norm_proj (m->points[f->p1],m->points[f->p2]);

    w1= vect_norm_proj (*a,m->points[f->p1]);
    w2= vect_norm_proj (*a,m->points[f->p2]);

    t= scprod(v1,v3);
    t= scprod(v1,w1);
    t= scprod(v3,w1);

    t= scprod(v2,v4);
    t= scprod(v2,w2);
    t= scprod(v4,w2);


    // ici on fait un test pour voire si le point a est bien "dans l angle" forme par v1 et v2, ainsi que v3 et v4
    // voire dessin doc. externe pour comprendre

    if ( ((scprod(v1,w1)>scprod(v1,v3))&&(scprod(v3,w1)>scprod(v1,v3))) && ((scprod(v2,w2)>scprod(v2,v4))&&(scprod(v4,w2)>scprod(v2,v4)))  ) {

      return 1;
    } 
    else {
      return 0;
    }

}

Vertex intersect (Vertex *a1,Face *f, Model *m) { // calcule l intersection de la droite passant par l origine et le point a (projete) et le plan de la face f du modele m

  // ATTENTION TRES IMPORTANT: il faut que la face soit calcule PROJETEE

  double l;
  Vertex k,a2,a3,b;

  k.enb=0;

  
  // la on calcule deux vecteurs definissant le plan (a partir des points de la face f)

  a2= vect_proj (m->points[f->p3],m->points[f->p1]);
  a3= vect_proj (m->points[f->p3],m->points[f->p2]);

  // la on a besoin en collone resultat du systeme d un point du plan (ici p1)

  b.x=m->points[f->p1].xp;
  b.y=m->points[f->p1].yp;
  b.z=m->points[f->p1].zp;

  // la on calcule le vecteur directeur de la droite. Ici on va prendre directo a1 (en coordonnees pas projetes). La on n a pas besoin des coordonnees projetes.

  // on resoud le systeme

  l= gauss_3_vect (&a2,&a3,a1,&b);

  if (l<0) { k.enb=-1;}

  // puis on renvoit le bon vertex

  k.xp=l*a1->x;
  k.yp=l*a1->y;
  k.zp=l*a1->z;

  return k;

}


// test_face teste si un point donn est bien compris dans une face, au niveau de la SPHERE UNITE. En fait le point est donc "projete" sur le plan
// de la face d abord.

// elle est subdivise en deux parties: premierement on calcule le point d intersection de la droite avec
// le plan d une face, puis on teste par produits scalaires si ce point est bien ds le triangle.

int test_face (Vertex *a, Face *f, Model *m) {

  Vertex k;

  k= intersect(a,f,m); //v contient donc les coordonnes d 'un point dans le plan de la face f 

  if (k.enb==-1) {

    //  printf("Other way.\n");

    return 0;

} // la c est que le point trouv va pas dans le meme sens que le vecteur Oa... donc ca peut pas marcher

  return point_is_in_face(&k,f,m);

}

// search_face renvoie la face de b dont le Vtx a est contenu dedans.
// attention: il faudra faire gaffe que la face est une face projete

int search_face (Vertex *a, Model *b) {

  int i;
  int bool;

  i= 0;
  bool = 0;

  while (bool==0 ) { // Bon ici on teste toutes les faces: tant que le point est pas dans une face, on continue

    // noter que ca pose problemes: le code de calcul n etant pas encore correct (bugs...) i depasse la valeur autorise et on plante

    if (i==b->nbf) { printf ("I can't compute the face of B in which is the first point of A...Exiting.\n");
    exit(0);
    }


    bool = test_face (a, &b->f[i] ,b);
    i++;
  }

  return i-1;

}

// specific_test teste si il y a bien intersection... 


 int specific_test (Vertex *k, Vertex *l, Vertex *m, Model *a, Edge *ea, Model *b, Edge *eb) {

   double a11,a21,a12,a22,b1,b2;
   //   double t,u;
   Vertex r;

   /*

   a12= k->x;
   a22= k->y;

   a11= b->points[eb.p1].xp-b->points[eb.p2].xp;
   a12= b->points[eb.p1].yp-b->points[eb.p2].yp;

   b1= b->points[eb.p1].xp;
   b2= b->points[eb.p1].yp;

   u= gauss_2 (a11,a12,a21,a22,b1,b2);

   m->x= u*k->x;
   m->y= u*k->y;
   m->z= u*k->z;


    if (i==2) {

    write_geomfile_inter("modela_inside_point.geom",a,ea.p1,*m );
exit(0);}

   */

   //  double xmax,xmin,ymax,ymin,zmax,zmin;
  

   a12= k->x;
   a22= k->y;

   a11= a->points[ea->p1].xp-a->points[ea->p2].xp;
   a21= a->points[ea->p1].yp-a->points[ea->p2].yp;

   b1= a->points[ea->p1].xp;
   b2= a->points[ea->p1].yp;

   r= gauss_2_fond (a11,a12,a21,a22,b1,b2);

   l->xp= r.x;

   //l->x= t*k->x;

   //  l->y= t*k->y;

   // l->z= t*k->z;



   // nouvelle ide

   if ((r.y<0) | (r.y>1))

     { return 0; }

   else {

   a12= k->x;
   a22= k->y;

   a11= b->points[eb->p1].xp-b->points[eb->p2].xp;
   a21= b->points[eb->p1].yp-b->points[eb->p2].yp;

   b1= b->points[eb->p1].xp;
   b2= b->points[eb->p1].yp;

   r= gauss_2_fond (a11,a12,a21,a22,b1,b2);

   m->xp= r.x;

   //m->x= u*k->x;
   //m->y= u*k->y;
   //m->z= u*k->z;


   //  if (i==2) {
      //printf("ggggggggggggggg");
      //write_geomfile_inter("modela_inside_point.geom",a,ea.p1,*m );
    //exit(0);

   //}

   if ((r.y<0) | (r.y>1)) { return 0; }

   else { 

     return 1;

}

   }

 }

 


Vertex intersect_edges (Model *a, Edge *ea, Model *b, Edge *eb) {

  // double a11,a12,a13,a21,a22,a23,a31,a32,a33,b1,b2,b3;
    double l;
    double o,p,q,d;

    Vertex k,a1,a2,a3,c;
   
    c.x= a->points[ea->p1].xp;
    c.y= a->points[ea->p1].yp;
    c.z= a->points[ea->p1].zp;

    a1.x= -(a->points[ea->p2].xp);
    a1.y= -(a->points[ea->p2].yp);
    a1.z= -(a->points[ea->p2].zp);
    
    a2.x= b->points[eb->p1].xp;
    a2.y= b->points[eb->p1].yp;
    a2.z= b->points[eb->p1].zp;
    
    a3.x= b->points[eb->p2].xp;
    a3.y= b->points[eb->p2].yp;
    a3.z= b->points[eb->p2].zp;
    
    l= gauss_3_vect (&a2,&a3,&a1,&c);
    
    // on norme k  maintenant...

    o= c.x-l*a1.x;
    p= c.y-l*a1.y;
    q= c.z-l*a1.z;
    
    d= sqrt(o*o+p*p+q*q);
    
    k.x= o/d;
    k.y= p/d;
    k.z= q/d;


    //  printf("%d",i);
    //  printf("\n");

    /*    

    if ((i==5)&&(j==1)) {

    write_geomfile_inter("modela_inside_point.geom",a,ea.p1,k );
    exit(0);

 

}

    */  

    return k;

}

